unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  PythonEngine, PythonGUIInputOutput, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    RichEdit1: TRichEdit;
    Button1: TButton;
    PythonEngine1: TPythonEngine;
    PythonGUIInputOutput1: TPythonGUIInputOutput;
    Button2: TButton;
    PythonDelphiVar1: TPythonDelphiVar;
    Button3: TButton;
    Edit1: TEdit;
    PythonModule1: TPythonModule;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure PythonDelphiVar1GetData(Sender: TObject; var Data: Variant);
    procedure PythonDelphiVar1SetData(Sender: TObject; Data: Variant);
    procedure PythonDelphiVar1Change(Sender: TObject);
    procedure PythonModule1Initialization(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
     PythonEngine1.ExecStrings( Memo1.Lines );
end;

procedure TForm1.Button2Click(Sender: TObject);
var  result : PPyObject;
begin
    with PythonEngine1 do
    begin
        result := PythonEngine1.EvalStrings( Memo1.Lines );
        if( Assigned( result ) ) then
        begin
            ShowMessage( Format( 'Eval result: %s',
                               [ PyObjectAsString( result ) ] ) );
            Py_DECREF( result );
        end
        else
            ShowMessage( 'Evaluation failed!' );
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    ShowMessage( 'Value of test: ' + PythonDelphiVar1.ValueAsString );
end;

procedure TForm1.PythonDelphiVar1GetData(Sender: TObject;
  var Data: Variant);
begin
    Data := Edit1.Text;    
end;

procedure TForm1.PythonDelphiVar1SetData(Sender: TObject; Data: Variant);
begin
    Edit1.Text := Data;
end;

procedure TForm1.PythonDelphiVar1Change(Sender: TObject);
begin
    with Sender as TPythonDelphiVar do
        ShowMessage( 'Test changed: ' + ValueAsString );
end;

function spam_foo( self, args : PPyObject ) : PPyObject; cdecl;
begin
    with GetPythonEngine do
    begin
        ShowMessage( 'args of foo: ' + PyObjectAsString( args ) );
        Result := Py_None;
        Py_IncRef( Result );
    end;
end;

procedure TForm1.PythonModule1Initialization(Sender: TObject);
begin
    with Sender as TPythonModule do
        AddMethod( 'foo', spam_foo, 'foo' );
end;

end.
