import sys
import string
import rfc822
import smtplib

def usage():

    print "Usage:  newsletter [-t] body-file [addr-file]"
    sys.exit( 1 )

def main():

    if( len( sys.argv ) < 2 or len( sys.argv ) > 4 ):
        usage()

    args = sys.argv[:]

    doSendMail = 1

    if( args[ 1 ] == "-t" ):
        args = args[ 1:]
        doSendMail = 0

    msgfile = args[ 1 ]

    if( len( args ) < 3 ):
        addrfile = "HADPemail.txt"

    else:
        addrfile = args[ 2 ]

    mf = open( msgfile, 'r' )
    af = open( addrfile, 'r' )

    if( not mf or not af ):
        usage()

    fromaddr = "Tres Seaver <tseaver@palladion.com>"
    CRLF     = "\r\n"

    toaddrs = [ '<tseaver@flash.net>' ]
    toaddrs.append( fromaddr  )

    for line in af.readlines():
        toaddrs.append( '<' + line[:-1] + '>' )

    msg = 'From: ' + fromaddr + CRLF
    msg = msg + 'To: "HADP members"' + CRLF
    msg = msg + 'Subject: HADP Meeting announcment' + CRLF + CRLF

    for line in mf.readlines():
        msg = msg + line[:-1] + CRLF

    print "Message length:      "   + `len( msg )`
    print "Number of addresses: "   + `len( toaddrs )`

    if( doSendMail ):
        server = smtplib.SMTP( 'smtp.neosoft.com' )
        server.set_debuglevel(1)
        server.sendmail( fromaddr, toaddrs, msg )
        server.quit()
    else :
        print "Testing: "
        print fromaddr
        for addr in toaddrs: print addr
        print
        print msg

if __name__ == '__main__':
    main()
